/// DNS Resolver sample program from ChatGPT
#include <iostream>

#include "Sockets/DNSResolver.hpp"

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        //std::cerr << "Usage: " << argv[0] << " <hostname>" << std::endl;
        //return 1;
    }

    const char* hostname = "git.redacted.cc";//argv[1];
    auto result = Sockets::ResolveDNS(hostname);

    if (result.Success)
    {
        for (auto hostname : result.ResolvedHostnames)
        {
            if (hostname.ProtocolVersion == Sockets::InternetProtocol::IPv4) {
                std::cout << "IPv4: " << hostname.Host  << std::endl;
            } else if (hostname.ProtocolVersion == Sockets::InternetProtocol::IPv6) {
                std::cout << "IPv6: " << hostname.Host  << std::endl;
            }
        }
    }

    return 0;
}
