#include "Sockets/UdpSocket_Old.hpp"
#include "Sockets/Sockets.hpp"


namespace Socket
{
    UdpSocket_Old::UdpSocket_Old(int family, int flags)
    {
        this->Open();
    }

	void UdpSocket_Old::Open()
	{
		this->Close();
		sock = (int)::socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	        if (sock < 0) {
	            CheckErrors_socket(errno);
		}
		if (this->IsClosed()) {
			//throw error();
		}
	}

	int UdpSocket_Old::Close()
	{
		int ret;
		if (!this->IsClosed()){
			if (Connected()) {
				#ifdef _WIN32
					ret = ::shutdown(sock, SD_BOTH);
				#else
					ret = ::shutdown(sock, SHUT_RDWR);
				#endif

				std::cout << ret << std::endl;

				if (ret < 0) {
					std::cout << "SHIT\n";
					CheckErrors_shutdown(errno);
				}
			}
		#ifdef _WIN32
			ret = ::closesocket(sock);
		#else
			ret = ::close(sock);
		#endif	
			if (ret < 0)
                CheckErrors_close(errno);
			sock = -1;
		}
		return 0;
	}


	void UdpSocket_Old::Bind(const IPAddress& ipAddress)
	{

        if (IsClosed())
            throw SocketBindingException("Socket has not been Open()'ed!");

		self_addr = ipAddress.operator sockaddr_in_t();
		self_addr_len = sizeof(self_addr);
		int opt = 1;
		int ret = ::setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (const char*)&opt, sizeof(opt));
		if (ret < 0)
            CheckErrors_setsockopt(errno);
		ret = ::bind(sock, (sockaddr_t*)&self_addr, self_addr_len);
		if (ret < 0)
            CheckErrors_bind(errno);
		ret = ::getsockname(sock, (sockaddr_t*)&self_addr, &self_addr_len);
		if (ret < 0)
            CheckErrors_getsockname(errno);
	}

	void UdpSocket_Old::Bind(uint16_t portno)
	{
		auto ipaddr = IPAddress::Any(portno);
		this->Bind(ipaddr);
	}
	void UdpSocket_Old::BindAny()
	{
		this->Bind(INPORT_ANY);
	}
	void UdpSocket_Old::BindAny(uint16_t& portno)
	{

        this->Bind(INPORT_ANY);
		//portno = IPAddress{self_addr}.port;

	}
    void UdpSocket_Old::Connect(const std::string& hostname, u16 port)
    {
        auto ipaddr = IPAddress::Resolve(hostname, port);
        this->Connect(ipaddr);
    }
	void UdpSocket_Old::Connect(const IPAddress& ipaddr)
	{
		peer_addr = ipaddr.operator sockaddr_in_t();
		peer_addr_len = sizeof(peer_addr);
		int ret = ::connect(sock, (sockaddr_t*)&peer_addr, peer_addr_len);
		if (ret < 0)
            CheckErrors_connect(errno);
		connected = true;
	}
	void UdpSocket_Old::Connect(u16 port)
	{
		auto ipaddr = IPAddress::Loopback(port);

        this->Connect(ipaddr);

	}

	bool UdpSocket_Old::Connected() const {
		return this->connected;
	}

    struct ReceivedPacket
    {
        IPAddress Sender;
        int Length;
        std::vector<u8> Payload;
    };



	int UdpSocket_Old::Receive(IPAddress& ipaddr, const u8 *message) const
	{
		sockaddr_in_t addr_in;
		socklen_t addr_in_len = sizeof(addr_in);
		u8 buffer[10 * 1024];
		int ret = ::recvfrom(sock, (char*)buffer, sizeof(buffer), 0, (sockaddr_t*)&addr_in, &addr_in_len);
		
		if (ret < 0) {
            using error = SocketReceiveException;

            CheckErrors_recvfrom(errno);
		}
		ipaddr = IPAddress(addr_in);
		message = buffer;
		return ret;
	}
	int UdpSocket_Old::Broadcast(int opt) const
	{
		int ret = ::setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (const char*)&opt, sizeof(opt));
		if (ret < 0)
            CheckErrors_setsockopt(errno);

		return 0;
	}

	void UdpSocket_Old::Interrupt() const
	{
        // What is this supposed to accomplish?
		//uint16_t portno = IPAddress{self_addr}.port;
		//auto ipaddr = IPAddress::Loopback(portno);
		//this->SendTo(ipaddr, msg_t{}, );
	}



    int UdpSocket_Old::Send(const u8 *data, unsigned int length, int flags)
    {
        int ret = ::send(sock,reinterpret_cast<const char*>(data), length, flags);

        if (ret < 0)
            CheckErrors_send(errno);
        return ret;
    }

    int UdpSocket_Old::Send(const std::vector<u8>& payload)
    {
        return this->Send(payload.data(), payload.size());
    }


    int UdpSocket_Old::SendTo(const IPAddress &ipaddr, const u8 *data, unsigned int length, int flags) {
        sockaddr_in_t addr_in = ipaddr.operator sockaddr_in_t();
        socklen_t addr_in_len = sizeof(addr_in);
        int ret = ::sendto(sock, (const char*)data, length, 0, (struct sockaddr*)&addr_in, addr_in_len);

        if (ret < 0)
            CheckErrors_sendto(errno);
        return ret;
    }

}
